import matplotlib.pyplot as plt
import numpy as np

class ComparisonGraph:
    def __init__(self, epochs, train_loss = None, val_loss = None, train_acc = None, val_acc = None):
        self.train_loss = train_loss
        self.val_loss = val_loss
        self.train_acc = train_acc
        self.val_acc = val_acc
        self.epochs = list(range(epochs))

    def draw(self):
        # Loss Graph
        plt.figure(figsize=(12, 4))
        ax1 = plt.subplot(1, 2, 1)
        ax1.set_title("Training Loss")
        plt.xlabel('Anzahl Epochen')
        plt.ylabel('Loss')
        plt.yticks(np.arange(0, max(self.train_loss + self.val_loss), step=0.1))
        if self.train_loss:
            ax1.plot(self.epochs, self.train_loss, color='blue', label='Train Loss', linewidth=0.5)
        if self.val_loss:
            ax1.plot(self.epochs, self.val_loss, color='orange', label='Val Loss', linewidth=0.5)
        ax1.legend(loc="upper right")

        # Accuracy Graph
        ax2 = plt.subplot(1, 2, 2)
        ax2.set_title("Training Accuracy")
        plt.xlabel('Anzahl Epochen')
        plt.ylabel('Accuracy')
        plt.yticks(np.arange(0, max(self.train_acc + self.val_acc), step=0.1))
        if self.train_acc:
            ax2.plot(self.epochs, self.train_acc, color='blue', label='Train Acc', linewidth=0.5)
        if self.val_acc:
            ax2.plot(self.epochs, self.val_acc, color='orange', label='Val Acc', linewidth=0.5)
        ax2.legend(loc="lower right")

        # Zeichne Graph
        plt.show()