from keras.callbacks import Callback

class TrainingHistory(Callback):

    def __init__(self):
        self.val_acc = []
        self.acc = []
        self.val_loss = []
        self.loss = []

    def on_train_begin(self, logs={}):
        self.train_accs = []
        self.val_accs = []

    def on_epoch_end(self, epoch, logs={}):
        self.acc.append(logs.get('acc'))
        self.val_acc.append(logs.get('val_acc'))
        self.val_loss.append(logs.get('val_loss'))
        self.loss.append(logs.get('loss'))
        return