from keras.models import Sequential
from keras.layers import Dense, Dropout
from keras import regularizers
from History import TrainingHistory
import numpy
numpy.random.seed(7)

class FeedForward:
    """Einfaches Modell für ein FF-Netzwerk"""

    def __init__(self, input_dim):
        self.model = Sequential()
        self.model.add(Dense(8, input_dim=input_dim, activation='relu', kernel_regularizer=regularizers.l2(0.01)))
        self.model.add(Dense(6, activation='relu', kernel_regularizer=regularizers.l2(0.01)))
        self.model.add(Dense(3, activation='softmax'))
        self.callback = TrainingHistory()
        print(self.model.summary())

    def train(self, X, Y, X_test, y_test):

        self.model.compile(loss='categorical_crossentropy', optimizer="adam", metrics=['accuracy'])
        self.model.fit( X, 
                        Y, 
                        validation_data=(X_test, y_test),
                        epochs=400, # 400
                        batch_size=4,
                        verbose=1,
                        callbacks=[self.callback])

    def evaluate(self, X, Y):
        scores = self.model.evaluate(X, Y)
        print("{}: {}%".format(self.model.metrics_names[1], round(scores[1]*100, 2)))
    
    def predict(self, X):
        return self.model.predict(X)